compile_mode :pop11 +strict;

lvars LAST = 42 ;
constant
    IM = 139968,
    IA =   3877,
    IC =  29573;

define gen_random( n ) -> ress;
;;; IC -> ress;
    (LAST * IA + IC) mod IM -> LAST;
    (n * LAST) / IM -> ress;
enddefine;


define heapsort(ra);
    lvars n, rra, i, j, l, ir, pp ;
    boundslist(ra) -> pp;
    pp(2) -> n;
    0 -> rra ;
    0 -> i ;
    0 -> j ;
    n div 2 + 1 -> l;
    n -> ir ;
    while true do
        if l > 1 then
            l - 1 -> l;
            ra(l) -> rra;
        else
            ra(ir) -> rra ;
            ra(1) -> ra(ir) ;

            ir -1 -> ir ;
            if ir = 1 then
                rra -> ra(1);
                return ;
            endif;

        endif;
        l -> i ;
        l * 2 -> j ;

        while j <= ir do
            if (j < ir) and ( ra(j) < ra(j+1)) then
                j + 1 -> j ;
            endif;

            if rra < ra(j) then
                ra(j) -> ra(i) ;
                j -> i;
                j + i -> j;
            else
                ir + 1 -> j;
            endif;
        endwhile;
        rra -> ra(i) ;
    endwhile;
enddefine;

;;; boundslist(my_tab) ==>
define do_sort();
    lvars i, l = poparglist, n, my_tab;
    ;;;  poparglist ==>
    if l == [] then
        'Run the program with an integer > 1 to determine size of array' =>
        'to be created and sorted' =>
        return();
    else
        strnumber(l(1)) -> n;
    endif;
    if not(n) then 10000 -> n; endif;
    ;;;  n =>
    80000 + 4*n -> popmemlim;
    newarray([1 ^n]) -> my_tab;
;;;my_tab ==>

    1 -> i ;
    while  i <= n do
        gen_random( 1.0d0 ) -> my_tab(i);
        i + 1 -> i;
    endwhile;

    if n < 100 then
        'Random array, before sorting' =>
        datalist(my_tab) ==>
    endif;

    heapsort(my_tab);

    if n < 100 then
        'After sorting' =>
        datalist(my_tab) ==>
    endif;

    'First element of sorted array'=>
    my_tab(1) =>
    'Final element of sorted array'=>
    my_tab(n) =>
enddefine;
