compile_mode :pop11 +strict;

/* 
  This program reomoves special chars from ved files. It allows to convert
  Poplog documentation into plain text form
*/


define conv_ved_file(file);
    lvars file, vrep, b;
    lvars vrep = vedfile_line_repeater(file);
;;; prevent line wrap on the output
    10000 -> poplinewidth;
    10000 -> poplinemax;

    while (vrep () ->> b) /= termin do
        lvars i, c;
        for i from 1 to datalength(b) do
             b(i) rem 256 -> c;
             if c > 128 then
                  ` ` -> b(i);
             endif;
        endfor;
        printf(b, '%p\n');
    endwhile;
enddefine;

;;; poparglist ==>
define do_conv();
    conv_ved_file(poparglist(1));
enddefine;
