/*
   Iteration converted into recursion, mixed version. Shows that
   one can mix tail calls (chain) with normal calls without stack
   overflow (as long as the number of normal calls is small
   enough).

*/

;;; lib showcode;
;;; true -> pop_show_code;

define adder_a(i, n, a);
   lvars i, n, a;
   if i < n then
     if i rem 100000 = 0 then
       return (adder_a(i + 1, n, a) + i);
     else
       (i + 1, n, a + i);
       chain (adder_a);
     endif;
   else
       return(a);
   endif;
enddefine;

define adder(n);
    lvars n;
    return(adder_a(1, n, 0));
enddefine;

adder(10000000) =>
