/* 
   A program to count how many times each of lines appeas on the
   standard input. It is based on a hash table (newmapping).

   Remark: since the program reads from the standard input one must
   run it as:

   poplog pop11 nslo.p

*/

compile_mode :pop11 +strict;

/*
  Get the standard input 
*/

vars si = Sys_cons_device('standard input', false, 0, "line", 0, false);

define count_words();
  lvars ht = newmapping([], 500, 0, true), cl, l, j = 0;
  line_repeater(si, 1000) -> cl;

  while (cl() ->> l) /= termin do
    j + 1 -> j;
    ht(l) + 1 -> ht(l);
  endwhile;

  printf(j, '%p linii\n');
  appproperty(ht, 
     procedure (key, value); 
       printf(value, '%p\t');
       printf(key, '%p\n');
     endprocedure);
enddefine;

#_TERMIN_IF DEF POPC_COMPILING
count_words();
